//
// Generated by JTB 1.1pre2
//

package hpjava.compiler.abstractexp;

import hpjava.compiler.syntaxtree.*;
import java.util.*;

public class AbstractExpressionVisitor {

   // f0 -> "="
   //       | "*="
   //       | "/="
   //       | "%="
   //       | "+="
   //       | "-="
   //       | "<<="
   //       | ">>="
   //       | ">>>="
   //       | "&="
   //       | "^="
   //       | "|="
   //
   public void visit(AssignmentNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   public void visit(AdditionAssignmentNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   public void visit(SubtractionAssignmentNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   public void visit(MultiplicationAssignmentNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   public void visit(DivisionAssignmentNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   public void visit(AndAssignmentNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   public void visit(InclusiveOrAssignmentNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   public void visit(ExclusiveOrAssignmentNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   public void visit(LeftShiftAssignmentNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   public void visit(RightShiftAssignmentNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   public void visit(ModulusAssignmentNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   public void visit(ExtensionRightShiftAssignmentNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   //
   // f0 -> ConditionalOrExpression()
   // f1 -> [ "?" Expression() ":" ConditionalExpression() ]
   //
   public void visit(ConditionalNode n) {
      n.condition.accept(this);
      n.trueResult.accept(this);
      n.falseResult.accept(this);
   }

   //
   // f0 -> ConditionalAndExpression()
   // f1 -> ( "||" ConditionalAndExpression() )*
   //
   public void visit(ConditionalOrNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   //
   // f0 -> InclusiveOrExpression()
   // f1 -> ( "&&" InclusiveOrExpression() )*
   //
   public void visit(ConditionalAndNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   //
   // f0 -> AndExpression()
   // f1 -> ( "^" AndExpression() )*
   //
   public void visit(ExclusiveOrNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   //
   // f0 -> ExclusiveOrExpression()
   // f1 -> ( "|" ExclusiveOrExpression() )*
   //
   public void visit(InclusiveOrNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   //
   // f0 -> InstanceOfExpression()
   // f1 -> ( ( "==" | "!=" ) InstanceOfExpression() )*
   //
   public void visit(EqualityNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   public void visit(InEqualityNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   //
   // f0 -> RelationalExpression()
   // f1 -> [ "instanceof" Type() ]
   //
   public void visit(InstanceOfNode n) {
      n.leaf.accept(this);
      n.type.accept(this);
   }

   //
   // f0 -> ShiftExpression()
   // f1 -> ( ( "<" | ">" | "<=" | ">=" ) ShiftExpression() )*
   //
   public void visit(LessNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   public void visit(GreaterNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   public void visit(LessThanEqNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   public void visit(GreaterThanEqNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   //
   // f0 -> ShiftExpression()
   // f1 -> ( ( "<" | ">" | "<=" | ">=" ) ShiftExpression() )*
   //
   public void visit(LeftShiftNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   public void visit(RightShiftNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   //
   // f0 -> AdditiveExpression()
   // f1 -> ( ( "<<" | ">>" | ">>>" ) AdditiveExpression() )*
   //
   public void visit(ExtensionRightShiftNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   //
   // f0 -> MultiplicativeExpression()
   // f1 -> ( ( "+" | "-" ) MultiplicativeExpression() )*
   //
   public void visit(AdditiveNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   public void visit(SubtractiveNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   //
   // f0 -> UnaryExpression()
   // f1 -> ( ( "*" | "/" | "%" ) UnaryExpression() )*
   //
   public void visit(MultiplicativeNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   public void visit(DivideNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   public void visit(ModuleNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   //
   // f0 -> ( "+" | "-" ) UnaryExpression()
   //       | PreIncrementExpression()
   //       | PreDecrementExpression()
   //       | UnaryExpressionNotPlusMinus()
   //
   public void visit(PlusNode n) {
      n.leaf.accept(this);
   }

   public void visit(MinusNode n) {
      n.leaf.accept(this);
   }

   //
   // f0 -> EqualityExpression()
   // f1 -> ( "&" EqualityExpression() )*
   //
   public void visit(AndNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   //
   // f0 -> "(" Type() ")" UnaryExpression()
   //       | "(" Type() ")" UnaryExpressionNotPlusMinus()
   //
   public void visit(CastNode n) {
      n.type.accept(this);
      n.leaf.accept(this);
   }

   //
   // f0 -> ( "~" | "!" ) UnaryExpression()
   //       | CastExpression()
   //       | PostfixExpression()
   //
   public void visit(ComplementNode n) {
      n.leaf.accept(this);
   }

   public void visit(LogicalNotNode n) {
      n.leaf.accept(this);
   }

   //
   // f0 -> "++"
   // f1 -> PrimaryExpression()
   //
   public void visit(PreIncrementNode n) {
      n.leaf.accept(this);
   }

   //
   // f0 -> "--"
   // f1 -> PrimaryExpression()
   //
   public void visit(PreDecrementNode n) {
      n.leaf.accept(this);
   }

   //
   // f0 -> PrimaryExpression()
   // f1 -> [ "++" | "--" ]
   //
   public void visit(PostfixNode n) {
      n.leaf.accept(this);
   }

   public void visit(PostfixAdditionNode n) {
      n.leaf.accept(this);
   }

   public void visit(PostfixSubtractionNode n) {
      n.leaf.accept(this);
   }

   //
   // f0 -> PrimaryExpression()
   // f1 -> ( "/" PrimaryExpression() )*
   //
   public void visit(GroupNode n) {
      n.left.accept(this);
      n.right.accept(this);
   }

   public void visit(PrimaryExpressionNode n) {
//      n.leaf.accept(this);
   }

   public void visit(TypeNode n) {
//      n.leaf.accept(this);
   }

}

