/*
 * File         : AbstractPrimaryExpressionInspector.java
 * Author       : Guansong Zhang
 * Created      : Fri Aug 14 17:20:13 1998
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1999/03/16 20:23:27 $
 */

// this is not finished.


package hpjava.compiler.abstractexp;

import hpjava.compiler.util.*;

import hpjava.compiler.syntaxtree.*;
import hpjava.compiler.unparser.*;

import hpjava.compiler.reflection.*;


public class AbstractPrimaryExpressionInspector 
  extends AbstractPrimaryExpressionVisitor 
{
  boolean hasMetPrefix=false;

  final int PREFIX = 0;
  final int SUFFIX = 1;

  private ClassReflector cr;
  private IntStack status=new IntStack();

  private StringBuffer image = new StringBuffer();

  public AbstractPrimaryExpressionInspector () {
    status.push(PREFIX);
    // for simple expression, it is a prefix.
  }

  public void visit (PrimaryConcatenation n) {
    status.push(PREFIX);
    n.prefix.accept(this);
    status.pop();

    status.push(SUFFIX);
    n.suffix.accept(this);
    status.pop();

    n.typeChecked = true;
  }

  public void visit (ThisDescriptor n) {
    if (status.peek()==PREFIX) {

    }
    else if (status.peek()==SUFFIX) {

    }
    else {
      throw new Error();
    }

    n.typeChecked = true;
  }

  public void visit (SuperDescriptor n) {
    if (status.peek()==PREFIX) {


    }
    else if (status.peek()==SUFFIX) {
      // can not be used as suffix
      throw new Error();
    }
    else {
      throw new Error();
    }

    n.typeChecked = true;
  }

  public void visit (LiteralDescriptor n) {
    if (status.peek()==PREFIX) {


    }
    else if (status.peek()==SUFFIX) {
      // literal can not be used as suffix
      throw new Error();
    }
    else {
      throw new Error();
    }

    n.typeChecked = true;
  }

  public void visit (ClassLiteralDescriptor n) {
    if (status.peek()==PREFIX) {


    }
    else if (status.peek()==SUFFIX) {
      // literal can not be used as suffix
      throw new Error();
    }
    else {
      throw new Error();
    }

    n.typeChecked = true;
  }

  public void visit (TripletOrExpressionListDescriptor n) {
    if (status.peek()==PREFIX) {
      throw new Error();
    }
    else if (status.peek()==SUFFIX) {

    }
    else {
      throw new Error();
    }

    n.typeChecked = true;
  }  
  
  public void visit (DistArraySecRefDimListDescriptor n) {
    if (status.peek()==PREFIX) {
      throw new Error();
    }
    else if (status.peek()==SUFFIX) {

    }
    else {
      throw new Error();
    }

    n.typeChecked = true;
  }
  
  public void visit (IdentifierDescriptor n) {
    if (status.peek()==PREFIX) {
      try {
        ClassReflectorDescriptor crd = 
          LocalVariableManager.classReflectorDescriptorOf(n.leaf);

        n.cr = new ClassReflectorByDescriptor(crd);
        
        this.cr = n.cr;
      }
      catch (NoSuchNameException e) {
        NodeToken node = n.leaf;
        // continue to find field. class .....
        System.out.println("?????????"+node.tokenImage);
        image.append(node.tokenImage);
      }
    }
    else if (status.peek()==SUFFIX) {
      NodeToken node = n.leaf;
      image.append('.');
      image.append(node.tokenImage);
    }
    else {
      throw new Error();
    }

    n.typeChecked = true;
  }  

  private String signatureOf(AllocatedShape n) {
    StringBuffer buffer = new StringBuffer();
    if (n.f0.which == 0 ) {
      NodeSequence sequence = (NodeSequence) n.f0.choice;
      NodeListOptional list = (NodeListOptional) sequence.elementAt(3);
      buffer.append(']');

      buffer.append(String.valueOf(1+list.size()));
      
      Expression exp = (Expression) sequence.elementAt(2);
      AbstractExpression aexp = ExpressionManager.lookup(exp);
      
      String typeName = aexp.getClassReflector().getName();

      if (typeName.equals("int")) {
        buffer.append('c');
      }
      else if(typeName.equals("hpjava.lang.Range")) {
        buffer.append('d');
      }
      else {
        throw new Error("compiling err, not finished");
      }

      if (list.present()) {
        for (int i = 0; i< list.size(); i++) {
          exp =(Expression) ( (NodeSequence)list.elementAt(i) ).elementAt(1);
          aexp = ExpressionManager.lookup(exp);

          typeName = aexp.getClassReflector().getName();

          if (typeName.equals("int")) {
            buffer.append('c');
          }
          else if(typeName.equals("hpjava.lang.Range")) {
            buffer.append('d');
          }
          else {
            throw new Error("compiling err, not finished");
          }
        }

      }
    }
    else {
      buffer.append('[');
    }

    return buffer.toString();
  }

   //
   // f0 -> "new" PrimitiveType() ArrayShapes()
   //       | "new" Name() ( ArrayShapes() | Arguments() [ ClassBody() ] )
   //

  public void visit (AllocationExpressionDescriptor n) {
    if (status.peek()==PREFIX) {
      ClassReflectorDescriptor crd = null;

      if (n.isPrimitiveTypeArrayAllocator()) {
        crd = n.primitiveType();
        
        int shapeNum = n.numberOfAllocatedShapes();

        if (shapeNum == 0) {
          if (n.isGSReference())
            crd = new ArrayReflectorDescriptor (crd, "]0");
          else
            throw new Error("Not finished");
        }
        else {
          for (int i = 0; i< n.numberOfAllocatedShapes(); i++) {
            AllocatedShapeDescriptor descriptor = n.allocatedShape(i);
            String image = signatureOf(descriptor.leaf);
            crd = new ArrayReflectorDescriptor(crd, image);
          }
        }

        int signatureNum = n.numberOfSignatures();

        if (signatureNum !=0)
          throw new Error("Not finished");

        n.cr = new ClassReflectorByDescriptor(crd);
      }
      else {
        //throw new Error("Not finished.");
      }

      /*

      AllocationExpression allocation = n.leaf;
      NodeSequence sequence = (NodeSequence) allocation.f0.choice;

      if (allocation.f0.which==0) {
        PrimitiveType type = (PrimitiveType) sequence.elementAt(1);

        crd = new PrimitiveTypeDescriptor(type);

        ArrayShapes shapes = (ArrayShapes) sequence.elementAt(2);
        NodeChoice choice = (NodeChoice) shapes.f0;
        
        if (choice.which ==0) {
          NodeSequence shapesSequence = (NodeSequence) choice.choice;
          
          NodeList allocatedList = 
            (NodeList) shapesSequence.elementAt(0);

          for (int i = 0; i < allocatedList.size(); i++) {

            String image = 
              signatureOf((AllocatedShape)allocatedList.elementAt(i));

            crd = new ArrayReflectorDescriptor(crd, image);
          }
          
          NodeListOptional signatureList = 
            (NodeListOptional) shapesSequence.elementAt(1);

          if (signatureList.present()) {
            throw new Error("Not finished.");
          }
        }
        else if (choice.which ==1) { //array init
          throw new Error("Not finished.");
        }
        else { // 0-dim
          throw new Error("Not finished.");
        }

        n.cr = new ClassReflectorByDescriptor(crd);
      }
      else {
        //throw new Error("Not finished.");
      }
      */

    }
    else if (status.peek()==SUFFIX) {
      throw new Error("Not finished.");
    }
    else {
      throw new Error();
    }

    n.typeChecked = true;
  }

  public void visit (ExpressionDescriptor n) {
    if (status.peek()==PREFIX) {


    }
    else if (status.peek()==SUFFIX) {
      // do nothing;
      throw new Error();
    }
    else {
      throw new Error();
    }

    n.typeChecked = true;
  }

  public void visit (ArgumentsDescriptor n) {
    if (status.peek()==PREFIX) {
      // do nothing;
      throw new Error();
    }
    else if (status.peek()==SUFFIX) {

    }
    else {
      throw new Error();
    }

    n.typeChecked = true;
  }

}

/*

to do list:

complete the code for different cases
Rewrite most of them :-0

*/
