/*
 * File         : AllocatedShapeDescriptor.java
 * Author       : Guansong Zhang
 * Created      : Wed Dec 16 23:14:14 1998
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1999/03/16 20:23:31 $
 */

package hpjava.compiler.abstractexp;

import hpjava.compiler.syntaxtree.*;
import hpjava.compiler.visitor.*;

import hpjava.compiler.reflection.*;

import hpjava.compiler.unparser.*;

public class AllocatedShapeDescriptor {
  public AllocatedShape leaf;

  public AllocatedShapeDescriptor(AllocatedShape shape) {
    leaf=shape;
  }

  public boolean isDistShape() {
    return (leaf.f0.which == 0 );
  }

  public int numberOfDims() {
    if (leaf.f0.which == 1) {
      return 1;
    }
    else {
      NodeSequence sequence = (NodeSequence) leaf.f0.choice;
      
      NodeListOptional list = (NodeListOptional) sequence.elementAt(3);

      return (1+list.size());
    }
  }

  public Expression dim(int i) {
    if (leaf.f0.which == 1) {
      NodeSequence sequence = (NodeSequence) leaf.f0.choice;
      if (i == 0)
        return (Expression) sequence.elementAt(1);
      else 
        throw new Error();
    }
    else {
      NodeSequence sequence = (NodeSequence) leaf.f0.choice;
      if (i == 0)
        return (Expression) sequence.elementAt(2);
      else {
        NodeListOptional list = (NodeListOptional) sequence.elementAt(3);
        NodeSequence dimSequence = (NodeSequence) list.elementAt(i-1);
        
        return (Expression) dimSequence.elementAt(1);
      }

    }
  }
}
