/*
 * File         : MethodReflectorByteCode.java
 * Author       : Guansong Zhang
 * Created      : Fri May 22 12:09:42 1998
 * Revision     : $Revision: 1.2 $
 * Updated      : $Date: 1998/10/07 22:56:14 $
 */

package hpjava.compiler.reflection;

import java.lang.reflect.*;

public class MethodReflectorByteCode extends MethodReflector {
  
  protected Method method;

  MethodReflectorByteCode (Method method) {
    this.method=method;
  }

  public ClassReflector getDeclaringClass() {
    return (new ClassReflectorByByteCode(this.method.getDeclaringClass()));
  }  
  
  public String getName() {
    return (this.method.getName());
  }

  public String getReturnTypeName() {
    return method.getReturnType().getName();
  }

  public ModifierReflector getModifier() {
    return (new ModifierReflector(this.method.getModifiers()));
  }

}
