/*
 * File         : AbstractExpressionTranslator.java
 * Author       : Guansong Zhang
 * Created      : Thu Oct  8 12:41:06 1998
 * Revision     : $Revision: 1.4 $
 * Updated      : $Date: 1999/03/16 20:29:42 $
 */


package hpjava.compiler.translator;

import hpjava.compiler.util.*;

import hpjava.compiler.syntaxtree.*;

import hpjava.compiler.unparser.*;

import hpjava.compiler.abstractexp.*;
import hpjava.compiler.reflection.*;


public class AbstractExpressionTranslator {
  AbstractExpression exp;

  public AbstractExpressionTranslator(AbstractExpression exp) {
    this.exp = exp; 
  }
  
  public void process() {
    AbstractExpressionProcessor processor = 
      new AbstractExpressionProcessor();

    this.exp.accept(processor);
  }
  
}

class AbstractExpressionProcessor 
  extends AbstractExpressionVisitor 
{

  private IntStack status=new IntStack();

  public AbstractExpressionProcessor () {

  }

  public void visit(PrimaryExpressionNode n) {
    AbstractPrimaryExpression exp 
      = PrimaryExpressionManager.lookup(n.leaf);

    AbstractPrimaryExpressionTranslator translator = 
      new AbstractPrimaryExpressionTranslator(exp);
    
    translator.process();
    
  }

}


